; data.asm
; draft 2008-02-29_m


GUITHREADINFO struct
  cbSize         DWORD ?
  flags          DWORD ?
  hwndActive     HWND  ?
  hwndFocus      HWND  ?
  hwndCapture    HWND  ?
  hwndMenuOwner  HWND  ?
  hwndMoveSize   HWND  ?
  hwndCaret      HWND  ?
  rcCaret        RECT <>
GUITHREADINFO ends

COMBOBOXINFO struct
  cbSize         DWORD ?
  rcItem         RECT <>
  rcButton       RECT <>
  stateButton    DWORD ?
  hwndCombo      HWND  ?
  hwndItem       HWND  ?
  hwndList       HWND  ?
COMBOBOXINFO ends

; RGNDATAHEADER STRUCT
;  dwSize        DWORD ?
;  iType         DWORD ?
;  nCount        DWORD ?
;  nRgnSize      DWORD ?
;  rcBound       RECT <>
; RGNDATAHEADER ENDS

; RGNDATA STRUCT
;  rdh          RGNDATAHEADER <>
;  Buffer       BYTE ?
; RGNDATA ENDS

; BLENDFUNCTION struct
;	 BlendOp              BYTE ?
;	 BlendFlags           BYTE ?
;	 SourceConstantAlpha  BYTE ?
;	 AlphaFormat          BYTE ?
; BLENDFUNCTION ends

.const

  height           equ 16
  id               equ 2000
  WS_EX_LAYERED    equ 00080000h
  CS_DROPSHADOW    equ 00020000h
  WS_EX_COMPOSITED equ 02000000h
  CAPTUREBLT       equ 40000000h

.data

  _hittester      db "HitTester",0
  _app            db "%9.8lX  //   HTSpy  by  kero   (2008-02-29_m)",0
  _wm_reg         db "<geocities.com/xmemor>",0
  _htshape        db "HTShape",0
  _htlab          db "HTLab",0
  _button         db "Button",0
  _static         db "Static",0
  _combo          db "ComboBox",0
  _combol         db "ComboLBox",0
  _NoneRegion     db "none",0
  _NULLREGION     db "null",0
  _SIMPLEREGION   db "simple",0
  _COMPLEXREGION  db "complex",0
  _user32         db "user32",0
  _lwa            db "SetLayeredWindowAttributes",0
  _ulw            db "UpdateLayeredWindow",0
  _ggr            db "GetGuiResources",0
  _pw             db "PrintWindow",0
  _wait           db "WAIT ...",0
  _dis            db "<dis>  ",0
  _lab            db " HTLab **",0
  _hwndstore      db "hw & id  store **",0
  _dwp            db "dwp",0
  _sm             db "sm  ",0
  _rect3          db "drag    (wm_mousemove)",0
  _rect4          db "drag    (wm_lbuttondown)",0
  _grid           db "dwp__dwp+cur__sm__sm+cur",0
  _unlock         db "Wheel: <*>/move/size (Shift,Alt)    Ctrl: store all hw / use root hw    F8: fix hw beneath cursor    F9: fix top hw",0
  _lock           db "Wheel: <*>/move/size (Shift,Alt)    Ctrl: store all hw    F8: HT-rgn (grid) / rare HT (Esc)    F9: grab menu beneath cursor",0
  _clck           db "*(*):  use also right(middle) click",0

  _menutmplt  db 0,0,0,0,80h,0,0,0,'m',0,'e',0,'n',0,'u',0,0,0
  
  _rect5 db "<%lX>    (wm_setcursor)",0
  _help  db " <1:%d>    <+%d>    <%s> ",13,10
         db " MouseWheel: <zoom>/<shift>/<ht>;  Right-Click: create/del/mark; ",13,10
         db " Cursor+Left/Down Arrow: move/size;  CapsLock: aim;  Shift/Ctrl/Alt: print hw ",0
  _frmt \
         db "  hw: %8.8lX    id /hm: %lu /%4.4lX    pid: %d    tid: %d",13,10,13,10
         db "  %s    <%s>    %s",13,10,13,10
         db "  %s",13,10,13,10
         db "  %s rt: [%d, %d, %d * %d]    w-cl: [%d,%d,%d,%d]    [%s region]",13,10,13,10
         db "  %s pt: (%d, %d) / lp: %8.8lX    dco: (%d, %d)",13,10,13,10
         db "  %sdwp /sm:  %s / %s",13,10,13,10
         db "  %s",0
  _ft    db "%s  HT %d :  [%d, %d, %d * %d]    [%s region]",0
  _ft2   db "%8.8lX  (%d, %d)  %s  %s",0
  _ft3   db "%d/%d, %d/%d",0
  _gu    db "gdi: %d    user: %d",0  
  _ss    db """%s"" / %s",0
  _ds    db "    %d      %s",0
  _cb    db "%8.8lX  :  "
  _d     db "%d"
  _z     db 0

  _F000  db "sc_size",0
  _F001  db "sc_size+wmsz_left",0         ; -
  _F002  db "sc_size+wmsz_right",0        ; -
  _F003  db "sc_size+wmsz_top",0          ; |
  _F004  db "sc_size+wmsz_topleft",0      ; \
  _F005  db "sc_size+wmsz_topright",0     ; /
  _F006  db "sc_size+wmsz_bottom",0       ; |
  _F007  db "sc_size+wmsz_bottomleft",0   ; /
  _F008  db "sc_size+wmsz_bottomright",0  ; \
  _F009  db "drag    sc_size+9",0
  _F00F  db "sc_separator",0
  _F010  db "sc_move",0
  _F011  db "sc_move+1",0
  _F012  db "sc_move+2",0
  _F020  db "sc_minimize",0
  _F030  db "sc_maximize",0
  _F040  db "sc_nextwindow",0
  _F050  db "sc_prevwindow",0
  _F060  db "sc_close",0
  _F070  db "sc_vscroll",0
  _F080  db "sc_hscroll",0
  _F090  db "sc_mousemenu",0
  _F100  db "sc_keymenu",0
  _F110  db "sc_arrange",0
  _F120  db "sc_restore",0
  _F130  db "sc_tasklist",0
  _F140  db "sc_screensave",0
  _F150  db "sc_hotkey",0
  _F160  db "sc_default",0
  _F170  db "sc_monitorpower",0
  _F180  db "sc_contexthelp",0

  _HTarea_ \
    db " <%d>",0
  _HTarea \
    db "HTERROR",0
    db "HTTRANSPARENT",0
    db "HTNOWHERE",0
    db "HTCLIENT",0
    db "HTCAPTION",0
    db "HTSYSMENU",0
    db "HTGROWBOX",0      ; HTSIZE
    db "HTMENU",0
    db "HTHSCROLL",0
    db "HTVSCROLL",0
    db "HTMINBUTTON",0    ; HTREDUCE
    db "HTMAXBUTTON",0    ; HTZOOM
    db "HTLEFT",0         ; HTSIZEFIRST
    db "HTRIGHT",0
    db "HTTOP",0
    db "HTTOPLEFT",0
    db "HTTOPRIGHT",0
    db "HTBOTTOM",0
    db "HTBOTTOMLEFT",0
    db "HTBOTTOMRIGHT",0  ; HTSIZELAST
    db "HTBORDER",0
    db "HTOBJECT",0       ; (where ??)
    db "HTCLOSE",0
    db "HTHELP",0

  _checkbox \
    db "timer *",0                  ; -3
    db "sc-drag **",0               ; -2  ; (size/pos hw drag**)
    db "ht-drag **",0               ; -1
    db "lock *",0                   ;  0
    db "ws_disabled *",0            ;  1
    db "ws_sysmenu    <",0          ;  2
    db "ws_child",0                 ;  3
    db "ws_popup",0                 ;  4
    db "   ws_overlapped",0         ;  5
    db "ws_border",0                ;  6
    db "ws_dlgframe",0              ;  7
    db "   ws_caption",0            ;  8
    db "ws_thickframe",0            ;  9
    db "ws_minimizebox, group",0    ; 10
    db "ws_maximizebox, tabstop",0  ; 11
    db "ws_vscroll",0               ; 12
    db "ws_hscroll",0               ; 13
    db "ws_clipchildren",0          ; 14
    db "ws_clipsiblings",0          ; 15
    db "ws_visible **",0            ; 16
    db "ws_maximize **",0           ; 17
    db "ws_minimize **",0           ; 18
    db "   ws_overlappedwindow",0   ; 19
    db "   ws_popupwindow",0        ; 20
    db "ws_ex_topmost",0            ; 21
    db "ws_ex_toolwindow *",0       ; 22
    db "ws_ex_appwindow",0          ; 23
    db "ws_ex_clientedge",0         ; 24
    db "ws_ex_staticedge",0         ; 25
    db "   ws_ex_windowedge",0      ; 26
    db "ws_ex_dlgmodalframe *",0    ; 27
    db "ws_ex_contexthelp",0        ; 28
    db "ws_ex_leftscrollbar",0      ; 29
    db "ws_ex_rtlreading",0         ; 30
    db "ws_ex_layoutrtl",0          ; 31
    db "ws_ex_noinheritlayout",0    ; 32
    db "ws_ex_right",0              ; 33
    db "ws_ex_transparent",0        ; 34
    db "ws_ex_layered **",0         ; 35
    db "ws_ex_composited",0         ; 36
    db "ws_ex_noactivate",0         ; 37
    db "ws_ex_mdichild",0           ; 38
    db "ws_ex_acceptfiles",0        ; 39
    db "ws_ex_controlparent",0      ; 40
    db "ws_ex_noparentnotify",0     ; 41
    db "cs_noclose",0               ; 42
    db "cs_dblclks",0               ; 43
    db "cs_hredraw",0               ; 44
    db "cs_vredraw",0               ; 45
    db "cs_owndc",0                 ; 46
    db "cs_parentdc",0              ; 47
    db "cs_classdc",0               ; 48
    db "cs_globalclass",0           ; 49
    db "cs_bytealignclient",0       ; 50
    db "cs_bytealignwindow",0       ; 51
    db "cs_savebits",0              ; 52
    db "cs_dropshadow *",0          ; 53
    db "cs_ime *    <<",0           ; 54
    db "cs_keycvtwindow",0          ; 55
    db "cs_nokeycvt",0              ; 56

  styles \
    dd  WS_DISABLED                 ;  1
    dd  WS_SYSMENU                  ;  2
    dd  WS_CHILD                    ;  3
    dd  WS_POPUP                    ;  4
    dd  WS_OVERLAPPED               ;  5
    dd  WS_BORDER                   ;  6
    dd  WS_DLGFRAME                 ;  7
    dd  WS_CAPTION                  ;  8
    dd  WS_THICKFRAME               ;  9
    dd  WS_MINIMIZEBOX              ; 10
    dd  WS_MAXIMIZEBOX              ; 11
    dd  WS_VSCROLL                  ; 12
    dd  WS_HSCROLL                  ; 13
    dd  WS_CLIPCHILDREN             ; 14
    dd  WS_CLIPSIBLINGS             ; 15
    dd  WS_VISIBLE                  ; 16
    dd  WS_MAXIMIZE                 ; 17
    dd  WS_MINIMIZE                 ; 18
    dd  WS_OVERLAPPEDWINDOW         ; 19
    dd  WS_POPUPWINDOW              ; 20
    dd  WS_EX_TOPMOST               ; 21
    dd  WS_EX_TOOLWINDOW            ; 22
    dd  WS_EX_APPWINDOW             ; 23
    dd  WS_EX_CLIENTEDGE            ; 24
    dd  WS_EX_STATICEDGE            ; 25
    dd  WS_EX_WINDOWEDGE            ; 26
    dd  WS_EX_DLGMODALFRAME         ; 27
    dd  WS_EX_CONTEXTHELP           ; 28
    dd  WS_EX_LEFTSCROLLBAR         ; 29
    dd  WS_EX_RTLREADING            ; 30
    dd  WS_EX_LAYOUTRTL             ; 31
    dd  WS_EX_NOINHERITLAYOUT       ; 32
    dd  WS_EX_RIGHT                 ; 33
    dd  WS_EX_TRANSPARENT           ; 34
    dd  WS_EX_LAYERED               ; 35
    dd  WS_EX_COMPOSITED            ; 36
    dd  WS_EX_NOACTIVATE            ; 37
    dd  WS_EX_MDICHILD              ; 38
    dd  WS_EX_ACCEPTFILES           ; 39
    dd  WS_EX_CONTROLPARENT         ; 40
    dd  WS_EX_NOPARENTNOTIFY        ; 41
    dd  CS_NOCLOSE                  ; 42
    dd  CS_DBLCLKS                  ; 43
    dd  CS_HREDRAW                  ; 44
    dd  CS_VREDRAW                  ; 45
    dd  CS_OWNDC                    ; 46
    dd  CS_PARENTDC                 ; 47
    dd  CS_CLASSDC                  ; 48
    dd  CS_GLOBALCLASS              ; 49
    dd  CS_BYTEALIGNCLIENT          ; 50
    dd  CS_BYTEALIGNWINDOW          ; 51
    dd  CS_SAVEBITS                 ; 52
    dd  CS_DROPSHADOW               ; 53
    dd  CS_IME                      ; 54
    dd  CS_KEYCVTWINDOW             ; 55
    dd  CS_NOKEYCVT                 ; 56

  WS_       dd WS_POPUP OR WS_CAPTION OR WS_MINIMIZEBOX OR WS_MAXIMIZEBOX OR WS_CLIPCHILDREN ; OR WS_VSCROLL OR WS_HSCROLL
  WSX_      dd WS_EX_TOPMOST OR WS_EX_DLGMODALFRAME
  CS_       dd 0
  chess     dd 5555AAAAh                ; for hbrush
  alpha     dd 128                      ; (0<=alpha<=255)
  top       dd 34                       ; rect1 (customized HT-zones)
  wdth      dd 150                      ; rect1
  tp        dd 454                      ; rect5
  lft       dd 8                        ; rect5
  sc5       dd 0F009h  ; SC_SIZE+9      ; value for rect5 (wParam of WM_SYSCOMMAND)
  rectw     RECT <10,40,620,620>        ; HTSpy window
  rects     RECT <170,34,420,height*11> ; info panel
  rect3     RECT <8,490,156,511>
  rect4     RECT <8,510,156,531>

.data?

  hinst     HINSTANCE ?
  hbrush    HBRUSH ?    ; 2x2-pixels chess brush
  hfont     HFONT ?     ; font for HTSpy
  hicon     HICON ?
  hw        HWND ?      ; fixed window
  htdwp     dd ?        ; DefWindowProc(WM_NCHITTEST) return value
  htsm      dd ?        ; SendMessageTimeout(WM_NCHITTEST) return value
  htx       dd ?        ; current column of HT-zone (via cursor pos)
  htz       dd ?        ; variable HT-value
  all_win   dd ?        ; all windows (+ message-only) counter
  top_win   dd ?        ; top-level windows (+ message-only) counter
  recreate  dd ?        ; flag: recreate HTSpy window (same thread, via left click to "cs_ime" checkbox)
  hterr     dd ?        ; flag: HTSpy window = HTERROR
  htcur     dd ?        ; flag: HT-zones = cursor-dependent
  wm_reg    dd ?        ; HTSpy registered message
  ht_last   dd 2 dup(?) ; last collected ht-region of fixed window (after "cursor over HT-grid + F8")  
  rect1     RECT <>
  rect5     RECT <>
  buff      db 128 dup(?)

; System cursors :
; IDC_ARROW            ; 32512
; IDC_IBEAM            ; 32513
; IDC_WAIT             ; 32514
; IDC_CROSS        ; + ; 32515
; IDC_UPARROW          ; 32516
; IDC_SIZE             ; 32640
; IDC_ICON             ; 32641
; IDC_SIZENWSE     ; \ ; 32642
; IDC_SIZENESW     ; / ; 32643
; IDC_SIZEWE       ; - ; 32644
; IDC_SIZENS       ; | ; 32645
; IDC_SIZEALL          ; 32646
; IDC_HAND             ; 32649
; IDC_APPSTARTING      ; 32650
; IDC_HELP             ; 32651
