; draft 2008-02-29
; WinOS>=2k

LayeredWindow proc uses ebx edi esi hWnd:HWND,alph:DWORD,way:DWORD

  local bfs:BLENDFUNCTION
  local rt:RECT

  invoke GetWindowLong,hWnd,GWL_EXSTYLE
  mov ebx,eax
  mov ecx,WS_EX_LAYERED
  and ebx,ecx
  .if ebx==0
     or eax,ecx
  .else
     not ecx
     and eax,ecx
  .endif
  invoke SetWindowLong,hWnd,GWL_EXSTYLE,eax
  invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED

  .if ebx==0
    invoke GetModuleHandle,offset _user32
    .if way==0
      mov ecx,offset _ulw
    .else
      mov ecx,offset _lwa
    .endif
    invoke GetProcAddress,eax,ecx
    .if eax==0
      invoke MessageBeep,0
      jmp @f
    .endif
    mov ebx,eax

    .if way==0
      
      invoke GetWindowRect,hWnd,addr rt
      invoke GetWindowDC,hWnd
      mov edi,eax
      invoke CreateCompatibleDC,edi
      mov esi,eax
      mov eax,rt.right
      sub eax,rt.left
      mov rt.right,eax
      mov ecx,rt.bottom
      sub ecx,rt.top
      mov rt.bottom,ecx
      xor edx,edx
      mov rt.left,edx
      mov rt.top,edx
      invoke CreateCompatibleBitmap,edi,eax,ecx
      push eax
      invoke SelectObject,esi,eax
      push eax
      
      invoke BitBlt,esi,0,0,rt.right,rt.bottom,edi,0,0,SRCCOPY OR CAPTUREBLT

;      invoke UpdateLayeredWindow,hWnd,edi,0,addr rt+8,esi,addr rt,0,addr bfs,ULW_ALPHA
      push ULW_ALPHA
      mov bfs.BlendOp,AC_SRC_OVER
      mov bfs.BlendFlags,0
      mov bfs.AlphaFormat,AC_SRC_OVER ; 0 instead of 1 (AC_SRC_ALPHA)
      mov eax,alph
      mov bfs.SourceConstantAlpha,al
      lea eax,bfs
      push eax
      push 0
      lea eax,rt
      push eax
      push esi
      add eax,8
      push eax
      push 0
      push edi
      push hWnd
      call ebx

      pop eax
      invoke SelectObject,esi,eax
      call DeleteObject
      invoke DeleteDC,esi
      invoke ReleaseDC,hWnd,edi

    .else
;      invoke SetLayeredWindowAttributes,hWnd,0,alph,LWA_ALPHA
      push LWA_ALPHA
      push alph
      push 0
      push hWnd
      call ebx
    .endif
  .endif
@@:  
;  invoke InvalidateRect,0,0,1  ; (resize ULW-window + cancel its WS_EX_LAYERED)
  ret
LayeredWindow endp
