; draft 2008-02-29_m


WndProc proc uses ebx edi esi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

  local ps:PAINTSTRUCT
  local pt:POINT
  local rt:RECT
  local buf[256]:BYTE
  local retval:DWORD

  mov eax,uMsg
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .if eax==WM_NCHITTEST

    .if hterr!=0
      mov eax,HTERROR
    .else
      .if htcur!=0
        invoke GetCursorPos,addr pt
        mov eax,pt.x
        and eax,0ffffh
        mov ecx,pt.y
        shl ecx,16
        or ecx,eax
      .else
        mov ecx,lParam
      .endif
      invoke ExtHitTest,hWnd,ecx,addr retval
      .if eax!=1 && eax!=2
        jmp @dwp
      .elseif eax==1
        mov eax,retval
      .else
        mov eax,htz
      .endif
    .endif
    jmp @ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_SETCURSOR

    invoke GetCursorPos,addr pt
    mov esi,pt.x
    mov eax,pt.y
    and esi,0ffffh
    shl eax,16
    or esi,eax  ; lParam for WM_NC(*)

    mov edi,wParam
    .if edi==hWnd
      xor eax,eax
      invoke DescendantWindowFromPoint,eax,pt.x,pt.y  ; (if hwst is non-SS_NOTIFY & non-subclassed => wParam!=hwst, where hwst=infopanel)
      mov edi,eax
    .endif

;    invoke GetDlgCtrlID,edi
;    invoke GetMenu,edi
    invoke GetWindowLong,edi,GWL_ID
    and eax,0ffffh
    push eax

;    invoke IsDlgButtonChecked,hWnd,id
    invoke SendDlgItemMessage,hWnd,id,BM_GETCHECK,0,0
    push eax

    mov ebx,lParam
    mov esi,ebx
;    invoke DefWindowProc,edi,WM_NCHITTEST,0,esi
;    mov retval,esi
;    mov esi,eax
    shr ebx,16      ; uMsg
    and esi,0ffffh  ; HT-value
    invoke MapWindowPoints,0,hWnd,addr pt,1
    invoke PtInRect_,addr rect5,pt.x,pt.y
    pop ecx
    pop edx
;----------------------------------------------------------------------------------------------------
    .if ebx==WM_MOUSEMOVE

      .if edx==id-6 ; && esi==HTCLIENT                                      ; (info panel)
        mov edx,IDC_SIZENWSE
      .elseif edx!=id-6 && eax!=0 && (esi<=HTMAXBUTTON || esi>=HTBORDER)    ; (rect5)
        mov ecx,sc5
        .if ecx==SC_SIZE+WMSZ_LEFT || ecx==SC_SIZE+WMSZ_RIGHT               ; F001, F002
          mov edx,IDC_SIZEWE                                                ; 32644  ; "-"
        .elseif ecx==SC_SIZE+WMSZ_TOP || ecx==SC_SIZE+WMSZ_BOTTOM           ; F003, F006
          mov edx,IDC_SIZENS                                                ; 32645  ; "|"
        .elseif ecx==SC_SIZE+WMSZ_TOPLEFT || ecx==SC_SIZE+WMSZ_BOTTOMRIGHT  ; F004, F008
          mov edx,IDC_SIZENWSE                                              ; 32642  ; "\"
        .elseif ecx==SC_SIZE+WMSZ_TOPRIGHT || ecx==SC_SIZE+WMSZ_BOTTOMLEFT  ; F005, F007
          mov edx,IDC_SIZENESW                                              ; 32643  ; "/"
        .else
          mov edx,IDC_CROSS                                                 ; 32515  ; "+"
        .endif
      .else
        jmp @dwp
      .endif
      invoke LoadCursor,0,edx
      invoke SetCursor,eax
;----------------------------------------------------------------------------------------------------
    .elseif ebx==WM_LBUTTONDOWN

      .if edx==id-6 ; && esi==HTCLIENT
        mov wParam,SC_SIZE+WMSZ_BOTTOMRIGHT  ; (info panel) resize window
        jmp @f
      .elseif edx!=id-6 && eax!=0            ; (rect5)
        mov eax,sc5
        mov wParam,eax
@@:
;        invoke DefWindowProc,edi,WM_SYSCOMMAND,wParam,0
        mov hWnd,edi
        mov uMsg,WM_SYSCOMMAND
      .endif
      jmp @dwp
;----------------------------------------------------------------------------------------------------
    .elseif ebx==WM_MBUTTONDOWN
    
      mov eax,hWnd

      .if edx==id-4                                        ; reload win.tree to combo
        invoke GetDlgItem,hWnd,id-4
        invoke WinListCombo,eax
        invoke SendDlgItemMessage,hWnd,id-4,CB_SHOWDROPDOWN,1,0

      .elseif edx==id+35 && ecx==BST_CHECKED               ; "ws_ex_layered **"
        invoke LayeredWindow,hw,alpha,0                    ; UpdateLayeredWindow

      .elseif edx==id+16 && ecx==BST_CHECKED               ; "ws_visible **"
        jmp @vis
      .elseif edx==id+17 && ecx==BST_CHECKED               ; "ws_maximize **"
        jmp @max
      .elseif edx==id+18 && ecx==BST_CHECKED               ; "ws_minimize **"
        jmp @min
      .elseif edx==id-1 || edx==id-2                       ; "sc-drag **", "ht-drag **"
        jmp @f

      .elseif edx==id-5                                    ; "htlab**"
        xor hterr,1
        invoke MessageBeep,0
        jmp @dwp

      .else
        jmp @dwp
      .endif
;----------------------------------------------------------------------------------------------------
    .elseif ebx==WM_RBUTTONDOWN

      mov eax,hWnd

      .if edx>=id-3 && edx<=id  ; "timer *", "sc-drag **", "ht-drag **","lock *"
@@:
        mov ebx,edx
        invoke SendDlgItemMessage,hWnd,ebx,BM_GETCHECK,0,0
;        .if eax==BST_CHECKED
;          mov eax,BST_UNCHECKED
;        .else
;          mov eax,BST_CHECKED
;        .endif
        xor eax,1
        invoke SendDlgItemMessage,hWnd,ebx,BM_SETCHECK,eax,0
        invoke PostMessage,hWnd,WM_COMMAND,ebx,0

      .elseif edx==id-4 && ecx==BST_CHECKED  ; restore initial ID/hMenu
        invoke CbString,hw,addr buf
        invoke SendDlgItemMessage,hWnd,id-4,CB_FINDSTRING,-1,addr buf
        invoke SendDlgItemMessage,hWnd,id-4,CB_GETITEMDATA,eax,0
        .if eax!=CB_ERR
          invoke SetWindowLong,hw,GWL_ID,eax  ; (unworkable for csrss's windows)
          invoke SetWindowPos,hw,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
          invoke InvalidateRect,hw,0,1
          invoke MessageBeep,0
        .endif

      .elseif edx==id+1 && ecx==BST_CHECKED  ; "ws_disabled *"
        invoke IsWindowEnabled,hw
;        xor eax,1
        .if eax==0
          inc eax  ; TRUE
        .else
          xor eax,eax  ; FALSE
        .endif
        invoke EnableWindow,hw,eax

      .elseif edx==id+27 && ecx==BST_CHECKED  ; "ws_ex_dlgmodalframe *"
        invoke SendMessageTimeout,hw,WM_GETICON,ICON_BIG,0,SMTO_ABORTIFHUNG,300,addr retval
        .if retval==0
          mov eax,hicon
        .else
          xor eax,eax
        .endif
        invoke SendMessageTimeout,hw,WM_SETICON,ICON_BIG,eax,SMTO_ABORTIFHUNG,300,0
        invoke ShowWindow,hw,SW_HIDE
        invoke ShowWindow,hw,SW_SHOWNORMAL

      .elseif edx==id+22 && ecx==BST_CHECKED  ; "ws_ex_toolwindow *"
        invoke IsWindowVisible,hw
        .if eax!=0
          invoke ShowWindow,hw,SW_HIDE
          mov esi,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED OR SWP_SHOWWINDOW
        .else
          mov esi,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
        .endif
        invoke GetWindowLong,hw,GWL_EXSTYLE
        mov ebx,eax
        mov ecx,WS_EX_TOOLWINDOW
        and ebx,ecx
        .if ebx==0
           or eax,ecx
        .else
           not ecx
           and eax,ecx
        .endif
        invoke SetWindowLong,hw,GWL_EXSTYLE,eax
        invoke SetWindowPos,hw,0,0,0,0,0,esi

      .elseif edx==id+35 && ecx==BST_CHECKED  ; "ws_ex_layered **"      
        invoke LayeredWindow,hw,alpha,1                               ; SetLayeredWindowAttributes

      .elseif edx==id+16 && ecx==BST_CHECKED  ; "ws_visible **"
@vis:
        invoke IsWindowVisible,hw
        .if eax==0
          mov eax,SW_SHOWNORMAL
        .else
          mov eax,SW_HIDE
        .endif
        jmp @f
      
      .elseif edx==id+17 && ecx==BST_CHECKED  ; "ws_maximize **"
@max:
        invoke IsZoomed,hw
        .if eax==0
          mov eax,SW_MAXIMIZE
        .else
          mov eax,SW_RESTORE
        .endif
        jmp @f
          
      .elseif edx==id+18 && ecx==BST_CHECKED  ; "ws_minimize **"
@min:
        invoke IsIconic,hw
        .if eax==0
          mov eax,SW_MINIMIZE
        .else
          mov eax,SW_RESTORE
        .endif
@@:
        .if ebx==WM_RBUTTONDOWN
          invoke ShowWindow,hw,eax
        .else
          invoke ShowWindowAsync,hw,eax
        .endif

      .elseif edx==id-5                       ; "htlab**"
        xor htcur,1
        invoke GetDlgItem,hWnd,id-5
        invoke InvalidateRect,eax,0,0
        jmp @dwp

      .elseif edx==id+53 && ecx==BST_CHECKED  ; "cs_dropshadow *"
        invoke IsWindowVisible,hw
        .if eax!=0
          invoke ShowWindow,hw,SW_HIDE
          mov esi,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED OR SWP_SHOWWINDOW
        .else
          mov esi,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED
        .endif
        invoke GetClassLong,hw,GCL_STYLE
        mov ebx,eax
        mov ecx,CS_DROPSHADOW
        and ebx,ecx
        .if ebx==0
           or eax,ecx
        .else
           not ecx
           and eax,ecx
        .endif
        invoke SetClassLong,hw,GCL_STYLE,eax
        invoke SetWindowPos,hw,0,0,0,0,0,esi

      .elseif edx==id+54  ; "cs_ime * <<"
        inc recreate      ; recreate HTSpy window with last WS_/WS_EX_/CS_ styles and with last window rect.
        invoke GetWindowRect,hWnd,addr rectw
        mov eax,rectw.left
        sub rectw.right,eax
        mov eax,rectw.top
        sub rectw.bottom,eax
        invoke GetWindowLong,hWnd,GWL_STYLE
        mov WS_,eax
        invoke GetWindowLong,hWnd,GWL_EXSTYLE
        mov WSX_,eax
        invoke GetClassLong,hWnd,GCL_STYLE
        mov ecx,eax
        mov edx,CS_IME
        or eax,edx
        .if eax==ecx
          not edx
          and eax,edx
        .endif
        mov CS_,eax
            invoke GetDlgItem,hWnd,id-6
            invoke GetWindowRect,eax,addr rects
            invoke MapWindowPoints,0,hWnd,addr rects,2
            mov eax,rects.left
            sub rects.right,eax
            mov eax,rects.top
            sub rects.bottom,eax
;        invoke PostMessage,hWnd,WM_CLOSE,0,0
        invoke DestroyWindow,hWnd

      .else
        jmp @dwp
      .endif
;----------------------------------------------------------------------------------------------------
    .else
      jmp @dwp
    .endif
    xor eax,eax
    inc eax
    jmp @ret
    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_MOUSEMOVE && wParam==MK_LBUTTON

    mov edx,offset rect3
    jmp @f

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_LBUTTONDOWN && wParam==MK_LBUTTON

    mov edx,offset rect4
@@:
    mov eax,lParam
    mov ecx,eax
    and eax,0ffffh
    shr ecx,16
    invoke PtInRect_,edx,eax,ecx
    .if eax!=0  ; window drag'n'drop variants
;;      invoke <DefWindowProc/SendMessage/PostMessage>,hWnd,WM_SYSCOMMAND,SC_SIZE+9,0    
;      mov uMsg,WM_SYSCOMMAND
;      mov wParam,SC_SIZE+9
;;      invoke <DefWindowProc/SendMessage/PostMessage>,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam      
      mov uMsg,WM_NCLBUTTONDOWN
      mov wParam,HTCAPTION
    .endif
    jmp @dwp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_COMMAND

    mov edi,wParam
    mov ecx,edi
    and edi,0ffffh
    shr ecx,16
;----------------------------------------------------------------------------------------------------
    .if edi>=id-3 && edi<=id+56 && ecx==BN_CLICKED
    
      invoke SendDlgItemMessage,hWnd,edi,BM_GETCHECK,0,0
      mov ebx,eax
      invoke SendDlgItemMessage,hWnd,id,BM_GETCHECK,0,0
      sub edi,id

      .if edi==0 && eax==BST_UNCHECKED
        mov byte ptr [buff],0

      .elseif edi==-3
        .if ebx==BST_CHECKED
          invoke SetTimer,hWnd,id,100,0
        .else
          invoke KillTimer,hWnd,id
        .endif

      .elseif edi>=1 && edi<=56 && eax==BST_CHECKED
        invoke CheckSetStyle,hWnd,hw,ebx,edi
        invoke CheckGetStyle,hWnd,hw

      .endif      
;----------------------------------------------------------------------------------------------------
    .elseif edi==id-4 && ecx==CBN_SELCHANGE
    
      invoke SendDlgItemMessage,hWnd,edi,CB_GETCURSEL,0,0
      mov edx,eax
      invoke SendDlgItemMessage,hWnd,edi,CB_GETLBTEXT,edx,addr buf
      invoke lstrlen,addr buf
      jmp @f
;----------------------------------------------------------------------------------------------------
    .elseif edi==id-4 && ecx==CBN_EDITCHANGE
    
      invoke SendDlgItemMessage,hWnd,edi,WM_GETTEXT,9,addr buf
@@:
      .if eax>=8
        mov bl,byte ptr [buf+8]
        mov byte ptr [buf+8],0
        invoke htodw,addr buf
        mov byte ptr [buf+8],bl
        mov ebx,eax
        invoke IsWindow,ebx
        .if eax!=0
          mov hw,ebx
          invoke SendDlgItemMessage,hWnd,id,BM_SETCHECK,BST_UNCHECKED,0
          invoke OnTimer,hWnd,1
          invoke SendDlgItemMessage,hWnd,id,BM_SETCHECK,BST_CHECKED,0
        .else
          invoke SendDlgItemMessage,hWnd,edi,CB_FINDSTRING,-1,addr buf
          .if eax!=CB_ERR
            invoke SendDlgItemMessage,hWnd,edi,CB_DELETESTRING,eax,0
          .endif
          invoke MessageBeep,0
        .endif
      .endif
;----------------------------------------------------------------------------------------------------
    .elseif edi==id-4 && ecx==CBN_DROPDOWN
    
      invoke GetKeyState,VK_CONTROL
      and eax,8000h
      .if eax!=0
        invoke GetDlgItem,hWnd,id-4
        invoke WinListCombo,eax
      .endif
      jmp @dwp
;----------------------------------------------------------------------------------------------------
    .elseif edi==id-5 && ecx==BN_CLICKED

      invoke CreateWindowEx,WS_EX_TOPMOST,\
        offset _htlab,offset _htlab,\
        WS_VISIBLE OR WS_POPUP OR WS_MINIMIZEBOX OR WS_MAXIMIZEBOX OR WS_CLIPCHILDREN OR WS_THICKFRAME OR WS_CAPTION,\
        10,10,450,400,0,0,hinst,0

    .endif

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_MOUSEWHEEL

;    invoke ExtHitTest,hWnd,lParam,addr retval

    mov eax,lParam
    mov ecx,eax
    and eax,0ffffh
    shr ecx,16
    mov pt.x,eax
    mov pt.y,ecx
    invoke MapWindowPoints,0,hWnd,addr pt,1
    invoke PtInRect_,addr rect1,pt.x,pt.y
    push eax
    invoke PtInRect_,addr rect5,pt.x,pt.y
    pop ecx

    mov edx,rect1.top
    add edx,height

    xor ebx,ebx
    .if wParam<80000000h
      dec ebx
    .else
      inc ebx
    .endif

    .if eax!=0
      add sc5,ebx
      jmp @f
    .elseif ecx!=0 && pt.y<edx
      add htz,ebx
@@:
      invoke GetCursorPos,addr pt
      invoke SetCursorPos,pt.x,pt.y
    .else
      shl ebx,2
      invoke GetKeyState,VK_SHIFT  ; drag rect1/rect5
      mov edi,eax
      invoke GetKeyState,VK_MENU  ;  drag vertical/horizontal
      mov ecx,8000h
      and edi,ecx
      and eax,ecx
      .if edi==0 && eax==0
        add tp,ebx
      .elseif edi==0 && eax!=0
        add lft,ebx
      .elseif edi!=0 && eax==0
        add top,ebx
      .elseif edi!=0 && eax!=0
        add wdth,ebx
      .endif
    .endif
    invoke InvalidateRect,hWnd,0,1
;    invoke RedrawWindow,hWnd,0,0,RDW_INVALIDATE OR RDW_ERASE OR RDW_ALLCHILDREN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_PAINT

    .if wParam==0
      invoke BeginPaint,hWnd,addr ps
    .else
      mov eax,wParam
    .endif
    mov ebx,eax
    invoke SendDlgItemMessage,hWnd,id,BM_GETCHECK,0,0
    invoke OnDraw,ebx,eax
    invoke GetClientRect,hWnd,addr rt
    invoke FrameRect,ebx,addr rt,hbrush
    .if wParam==0
      invoke EndPaint,hWnd,addr ps
    .endif

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_PRINTCLIENT
  
    invoke SendMessage,hWnd,WM_PAINT,wParam,lParam
    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_CTLCOLORSTATIC

    invoke GetWindowLong,lParam,GWL_ID
    .if eax==id-5 && htcur!=0
      jmp @dwp
    .endif
    invoke SetBkMode,wParam,TRANSPARENT
    invoke GetStockObject,WHITE_BRUSH
    jmp @ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_WINDOWPOSCHANGED

;    invoke SendNotifyMessage,HWND_BROADCAST,wm_reg,WM_WINDOWPOSCHANGED,hWnd
    invoke nGetKeyState
    invoke EnumWindows,addr Tick,eax
    jmp @dwp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;    
  .elseif eax==WM_SIZE

    invoke InvalidateRect,hWnd,0,1
    jmp @dwp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_TIMER && wParam==id

    invoke OnTimer,hWnd,0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_CREATE
  
    invoke CreateChildren,hWnd
    invoke wsprintf,addr buf,offset _app,hWnd
    invoke SetWindowText,hWnd,addr buf
    invoke SetTimer,hWnd,id,20,0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_DESTROY

    invoke KillTimer,hWnd,id
    invoke PostQuitMessage,0
    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .else
@dwp:
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam
;    invoke DefFrameProc,hWnd,0,uMsg,wParam,lParam
    jmp @ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .endif
  xor eax,eax
@ret:
  ret
WndProc endp
