; HTLab (part of HTSpy)
; draft 2008-02-29_m

;include FromPoint.asm


HTLabProc proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  local pt:POINT
  local rt:RECT
  local rt2:RECT
  local ps:PAINTSTRUCT
  local bu[10]:DWORD
  local buffer[16]:BYTE
  local buf[256]:BYTE
  local buf2[256]:BYTE
  local lparam:DWORD
  local retval:DWORD

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  invoke GetCursorPos,addr pt

  lea edi,bu
  xor ecx,ecx
  xor edx,edx
  .while ecx<10
    mov dword ptr [edi+4*ecx],edx
    inc ecx
  .endw
  mov ecx,pt.x
  mov dword ptr [edi+6*4],ecx
  mov ecx,pt.y
  mov dword ptr [edi+7*4],ecx
  mov ecx,hWnd
  mov dword ptr [edi+8*4],ecx

  mov ecx,wm_reg
  mov eax,uMsg
  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .if eax==WM_NCHITTEST
  
    invoke EnumChildWindows,hWnd,addr RectFromPoint,edi
    mov eax,dword ptr [edi]
    test eax,eax
    jnz @f
    mov eax,dword ptr [edi+2*4]
    test eax,eax
    jnz @f
    jmp @dwp
@@:
    invoke GetWindowLong,eax,GWL_USERDATA
;    jmp @ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_SETCURSOR
  
    mov eax,dword ptr [edi+6*4]
    mov ecx,dword ptr [edi+7*4]
    invoke InfoFromPoint,hWnd,eax,ecx
;    inc dword ptr [edi+3*4]  ; (mouse tracking)
    inc dword ptr[edi+4]
    invoke EnumChildWindows,hWnd,addr RectFromPoint,edi
    mov edx,dword ptr[edi]
    mov ecx,dword ptr[edi+2*4]
    mov eax,lParam
    shr eax,16
    .if edx!=0 && ecx!=0 && eax==WM_MOUSEMOVE
      invoke LoadCursor,0,32515 ; cursor "+"
      invoke SetCursor,eax
      xor eax,eax
      jmp @ret
    .elseif edx!=0 && ecx!=0 && eax==WM_LBUTTONDOWN
      mov hWnd,edx
      mov uMsg,WM_SYSCOMMAND
      mov wParam,SC_SIZE+9 ; SC_MOVE+1 ; SC_MOVE+2 ;
    .elseif ecx==0 && eax==WM_RBUTTONDOWN
      inc dword ptr [edi+3*4]
      invoke RectFromPoint,hWnd,edi  ; SetPixel (yellow)
    .elseif edx!=0 && ecx!=0 && eax==WM_RBUTTONDOWN
      invoke DestroyWindow,edx
    .elseif edx==0 && ecx!=0 && eax==WM_RBUTTONDOWN
      mov eax,dword ptr[edi+4*4]
      mov pt.x,eax
      mov eax,dword ptr[edi+5*4]
      mov pt.y,eax
      invoke MapWindowPoints,0,hWnd,addr pt,1
      sub pt.y,26
      invoke CreateWindowEx,WS_EX_TOOLWINDOW,\ ; OR WS_EX_TRANSPARENT,\
        offset _static,0,WS_VISIBLE OR WS_CHILD OR WS_CLIPSIBLINGS OR WS_BORDER OR SS_CENTER,\
        pt.x,pt.y,40,40,hWnd,0,hinst,0
      mov ebx,eax
      invoke SetWindowPos,ebx,HWND_TOP,0,0,0,0,SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED    
      jmp @f
    .endif
    jmp @dwp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_CREATE

    invoke LoadMenuIndirect,offset _menutmplt
    invoke SetMenu,hWnd,eax                   ; let'l be HTMENU :)
    invoke GetSystemMetrics,SM_CYCAPTION
    shl eax,16                                ; HTLab's USERDATA high-order word: initial nccalcsize shift (=SM_CYCAPTION for current theme)
    mov ecx,2                                 ; HTLab's USERDATA low-order word: initial zoom (=1:2)    
    or eax,ecx
    invoke SetWindowLong,hWnd,GWL_USERDATA,eax
    invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_NOACTIVATE OR SWP_FRAMECHANGED
    invoke CreateWindowEx,WS_EX_TOOLWINDOW,\ ; OR WS_EX_TRANSPARENT,\
      offset _static,0,WS_VISIBLE OR WS_CHILD OR WS_CLIPSIBLINGS OR WS_BORDER OR SS_CENTER,\
      4,40,40,40,hWnd,id,hinst,0
    mov ebx,eax
    invoke SetWindowPos,ebx,HWND_BOTTOM,0,66,400,48,SWP_FRAMECHANGED
@@:
    invoke SetWindowLong,ebx,GWL_USERDATA,HTCAPTION  ; Static's USERDATA: initial HT (=HTCAPTION)
;    invoke GetStockObject,DEFAULT_GUI_FONT
    mov eax,hfont
    invoke SendMessage,ebx,WM_SETFONT,eax,1
    xor eax,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_MOUSEMOVE || eax==WM_NCMOUSEMOVE

    invoke GetKeyState,VK_LEFT ; drag
    and eax,8000h
    mov ebx,eax
    invoke GetKeyState,VK_DOWN ; resize
    and eax,8000h
    mov esi,eax
    inc dword ptr[edi+4]
    invoke EnumChildWindows,hWnd,addr RectFromPoint,edi
    mov eax,dword ptr[edi]
    mov ecx,dword ptr[edi+2*4]
    .if ebx!=0 || esi!=0
      .if ebx!=0
        mov wParam,SC_SIZE+9 ; SC_MOVE+1 ; SC_MOVE+2
      .elseif esi!=0
        mov wParam,SC_SIZE+8 ; (WMSZ_BOTTOMRIGHT)
      .endif
      mov uMsg,WM_SYSCOMMAND      
      .if eax!=0
        mov hWnd,eax
      .else
        .if ecx!=0
          mov hWnd,ecx
        .endif
      .endif
    .endif
    jmp @dwp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_MOUSEWHEEL
    xor esi,esi
    inc esi
    invoke EnumChildWindows,hWnd,addr RectFromPoint,edi
    mov ebx,dword ptr[edi]
    test ebx,ebx
    jnz @f
    mov ebx,dword ptr[edi+2*4]
    test ebx,ebx
    jnz @f
    mov ebx,hWnd
    invoke DefWindowProc,ebx,WM_NCHITTEST,0,lParam
    mov esi,eax
    invoke GetWindowLong,ebx,GWL_USERDATA
    mov ecx,eax
    and eax,0ffffh
    shr ecx,16
    mov edx,dword ptr [edi+9*4]
    .if esi==HTNOWHERE && edx!=0 ; (cursor over HTLab window)
      .if wParam<80000000h
        dec cx
        .if cx<=0
          inc cx
        .endif
      .else
        inc cx
      .endif
    .else      
      .if wParam<80000000h
        dec ax
        .if ax<=0
          inc ax
        .endif
      .else
        inc ax
      .endif
    .endif
    shl ecx,16
    or eax,ecx
    jmp @@@
@@:
    invoke GetWindowLong,ebx,GWL_USERDATA
    .if wParam<80000000h
      dec eax
    .else
      inc eax
    .endif
@@@:
    invoke SetWindowLong,ebx,GWL_USERDATA,eax
    mov eax,dword ptr [edi+6*4]
    mov ecx,dword ptr [edi+7*4]
    invoke InfoFromPoint,hWnd,eax,ecx
    mov edx,dword ptr [edi+9*4]    
    .if esi==HTNOWHERE && edx!=0
      invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_NOACTIVATE OR SWP_FRAMECHANGED
    .endif
    jmp @f
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==ecx  ; wm_reg
@@:  
    invoke GetDC,hWnd
    mov ebx,eax
    invoke ZoomFromPoint,hWnd,eax,pt.x,pt.y,1,lParam
    invoke ReleaseDC,hWnd,ebx
    xor eax,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;    
  .elseif eax==WM_SIZE
    invoke GetDlgItem,hWnd,id
    test eax,eax
    jz @dwp
    mov ebx,eax
    invoke GetWindowRect,ebx,addr rt
    invoke MapWindowPoints,0,hWnd,addr rt,2
    mov ecx,lParam
    and ecx,0ffffh
    invoke SetWindowPos,ebx,HWND_BOTTOM,0,rt.top,ecx,48,SWP_FRAMECHANGED
    invoke InvalidateRect,ebx,0,1
    jmp @dwp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_CTLCOLORSTATIC
  
;    invoke GetWindowLong,lParam,GWL_ID
;    .if eax==id
;      invoke GetStockObject,WHITE_BRUSH
;    .else
      invoke GetClassLong,hWnd,GCL_HBRBACKGROUND  ; hbrush
;    .endif
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_NCCALCSIZE
  
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam  ;(!) lParam before DWP -> window rect, lParam after DWP -> client rect
    mov ebx,lParam
    invoke GetWindowLong,hWnd,GWL_USERDATA
    shr eax,16
    add dword ptr [ebx],eax     ; .left
    add dword ptr [ebx+4],eax   ; .top
    sub dword ptr [ebx+2*4],eax ; .right
    sub dword ptr [ebx+3*4],eax ; .bottom
    xor eax,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .elseif eax==WM_NCPAINT
  
    invoke GetWindowRect,hWnd,addr rt
    mov edi,rt.left
    mov esi,rt.top
    invoke DefWindowProc,hWnd,WM_NCCALCSIZE,FALSE,addr rt  ;  "legitimate" client rect (screen coordinates)
    mov eax,rt.left
    and eax,0ffffh
    mov ecx,rt.top
    shl ecx,16
    or eax,ecx
    mov lparam,eax  ; (x,y) -> lParam for WM_NC*
    sub rt.left,edi
    sub rt.top,esi
    sub rt.right,edi
    sub rt.bottom,esi
    invoke GetWindowLong,hWnd,GWL_STYLE  ; (also need test WS_EX_LEFTSCROLLBAR, WS_EX_LAYOUTRTL, ...)
    mov ebx,eax
    and eax,WS_VSCROLL
    .if eax!=0
      invoke GetSystemMetrics,SM_CXVSCROLL
    .endif
    add rt.right,eax
    push eax
    and ebx,WS_HSCROLL
    .if ebx!=0
      invoke GetSystemMetrics,SM_CYHSCROLL
    .endif
    add rt.bottom,eax
    push eax
    invoke GetClientRect,hWnd,addr rt2
    pop eax
    add rt2.bottom,eax
    pop eax
    add rt2.right,eax
    invoke MapWindowPoints,hWnd,0,addr rt2,2
    sub rt2.left,edi
    sub rt2.top,esi
    sub rt2.right,edi
    sub rt2.bottom,esi
    mov esi,rt.top
    mov eax,rt2.top
    mov rt.top,eax
    invoke CreateRectRgnIndirect,addr rt
    mov ebx,eax
    invoke CreateRectRgnIndirect,addr rt2
    push eax
    invoke CombineRgn,ebx,ebx,eax,RGN_DIFF
    call DeleteObject
    mov rt.top,esi
    invoke GetWindowDC,hWnd    
    mov esi,eax
    invoke GetStockObject,WHITE_BRUSH
    invoke FillRgn,esi,ebx,eax
    invoke DeleteObject,ebx
    mov eax,rt2.top
    mov rt.bottom,eax
    invoke GetStockObject,WHITE_BRUSH
    invoke FillRect,esi,addr rt,eax
    invoke DefWindowProc,hWnd,WM_NCHITTEST,0,lparam
    mov ebx,eax
    add rt.top,2
    sub rt2.top,1
    mov ecx,rt.left
    add rt.left,2
    .if ebx!=HTNOWHERE
      invoke MoveToEx,esi,ecx,rt2.top,0
      invoke LineTo,esi,rt.right,rt2.top
    .endif
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam
    invoke GetWindowRect,hWnd,addr rt
    mov eax,rt.left
    sub rt.right,eax
    mov eax,rt.top
    sub rt.bottom,eax
    xor eax,eax
    mov rt.left,eax
    mov rt.top,eax
;    invoke GetClassLong,hWnd,GCL_HBRBACKGROUND    
    invoke FrameRect,esi,addr rt,hbrush
    invoke ReleaseDC,hWnd,esi
    invoke InvalidateRect,hWnd,0,1
    xor eax,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
  .elseif eax==WM_CLOSE
  
    invoke SetWindowPos,hWnd,HWND_BOTTOM,0,0,0,0,SWP_FRAMECHANGED
    invoke DestroyWindow,hWnd
    xor eax,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .else
@dwp:
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  .endif
@ret:
  ret
HTLabProc endp
