; draft 2008-02-29


HT_region_info proc uses ebx edi esi hWnd:HWND,HT:DWORD,param:DWORD,param2:DWORD,param3:DWORD

  local hrgn:HRGN     ; combination of all regions
  local hr:HRGN
	local Inline:DWORD  ; inline region state
	local rt:RECT
	local rt2:RECT
  local Wdth:DWORD
  local Hght:DWORD
  local retval:DWORD
  local bu[16]:BYTE
  local buffer[16]:BYTE

  .if param==0
    mov ecx,offset _dwp
  .else
    mov ecx,offset _sm
  .endif
  invoke lstrcpy,addr bu,ecx

  invoke GetWindowRect,hWnd,addr rt

  mov eax,rt.right
  sub eax,rt.left
  mov Wdth,eax
  mov eax,rt.bottom
  sub eax,rt.top
  mov Hght,eax
	xor ebx,ebx  ; start location of a region
	xor edi,edi  ; X
	xor esi,esi  ; Y
	mov Inline,ebx
	mov hrgn,ebx

	.while esi< Hght

		.while edi<= Wdth
		
      mov eax,rt.left
      add eax,edi
      mov ecx,rt.top
      add ecx,esi

      .if param2!=0
        push eax
        push ecx
        invoke SetCursorPos,eax,ecx
        pop ecx
        pop eax
      .endif

      and eax,0ffffh
      shl ecx,16
      or ecx,eax

      .if param==0
        invoke DefWindowProc,hWnd,WM_NCHITTEST,0,ecx
      .else
        invoke SendMessageTimeout,hWnd,WM_NCHITTEST,0,ecx,SMTO_ABORTIFHUNG,300,addr retval
        mov eax,retval
      .endif

			.if eax!=HT
				jmp @f
			.elseif edi==Wdth
@@:
				.if Inline!=0
					mov Inline,0
					mov eax,esi
					inc eax
					invoke CreateRectRgn,ebx,esi,edi,eax

					.if hrgn==0
						mov hrgn,eax
					.else
            push eax
						invoke CombineRgn,hrgn,hrgn,eax,RGN_OR
						call DeleteObject
					.endif
				.endif

			.else
				.if Inline==0
					inc Inline
					mov ebx,edi
				.endif
			.endif

			inc edi
		.endw

		inc esi
		xor edi,edi

		invoke GetAsyncKeyState,VK_ESCAPE
    and eax,8000h
    .break .if (eax)

	.endw
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  .if hrgn!=0

    .if param3!=0
      invoke CreateRectRgn,0,0,0,0
      mov hr,eax
      invoke GetWindowRgn,hWnd,hr
      mov ebx,eax
      invoke CreateRectRgn,0,0,0,0
      push eax
      .if ebx!=ERROR && ebx!=NULLREGION
        mov eax,hr
      .endif
      invoke CombineRgn,hrgn,hrgn,eax,RGN_AND
      call DeleteObject
      invoke DeleteObject,hr
    .endif

;    invoke GetRegionData,hrgn,0,0
;    mov edi,eax ; dwCount
;    invoke VirtualAlloc,0,edi,MEM_COMMIT,PAGE_READWRITE
;    mov esi,eax ; lpRgnData
;    invoke GetRegionData,hrgn,edi,esi
;    ...
;    invoke VirtualFree,esi,0,MEM_RELEASE

    mov edi,rt.left
    mov esi,rt.top
    invoke GetRgnBox,hrgn,addr rt
    mov ebx,eax
    mov edx,rt.left
    mov ecx,rt.top
    neg edx
    neg ecx
    add rt.right,edx
    sub edi,edx
    add rt.bottom,ecx
    sub esi,ecx
    invoke OffsetRgn,hrgn,edx,ecx

    .if rt.right!=0 && rt.bottom!=0
      invoke HT_name,addr buffer,HT
      invoke wsprintf,addr buff,offset _ft2,hWnd,rt.left,rt.top,addr bu,addr buffer
      invoke CreateWindowEx,WS_EX_TOPMOST OR WS_EX_TOOLWINDOW,offset _htshape,addr buff,WS_POPUP OR WS_VISIBLE OR WS_BORDER,edi,esi,rt.right,rt.bottom,hWnd,0,hinst,0
      mov edi,eax
      invoke SetWindowRgn,edi,hrgn,1
      invoke IsWindowVisible,edi
      .if eax==0
        invoke SetWindowLong,edi,GWL_HWNDPARENT,0  ; for root message-only window ("Message" class)
      .endif
      xor eax,eax
      mov rt2.left,eax
      mov rt2.top,eax
      mov eax,rt.right
      mov rt2.right,eax
      mov eax,rt.bottom
      mov rt2.bottom,eax
      invoke GetWindowDC,edi
      mov esi,eax
      invoke RectVisible,esi,addr rt2
      .if eax==0
        invoke SetWindowPos,edi,0,0,0,0,0,SWP_NOZORDER OR SWP_NOSIZE OR SWP_FRAMECHANGED
      .endif
      invoke ReleaseDC,edi,esi
    .else
      invoke DeleteObject,hrgn
    .endif
;;    invoke DeleteObject,hrgn

    .if ebx==NULLREGION             ; 1
      mov eax,offset _NULLREGION
    .elseif ebx==SIMPLEREGION       ; 2
      mov eax,offset _SIMPLEREGION
    .elseif ebx==COMPLEXREGION      ; 3
      mov eax,offset _COMPLEXREGION
    .endif
  .else ; =0
    xor eax,eax
    mov rt.left,eax
    mov rt.top,eax
    mov rt.right,eax
    mov rt.bottom,eax
    mov eax,offset _NoneRegion
  .endif
  invoke wsprintf,addr buff,offset _ft,addr bu,HT,rt.left,rt.top,rt.right,rt.bottom,eax
	ret
HT_region_info endp
