; draft 2008-02-29


ZoomFromPoint proc uses ebx edi esi hWnd:HWND,hdc:HDC,ptx:DWORD,pty:DWORD,CaptBlt:DWORD,lP:DWORD  ; (CaptBlt!=0 <=> CAPTUREBLT for BitBlt)

  local rt:RECT
  local hdcmem:HDC
  local hW:HWND
  local top_to:DWORD
  local width_to:DWORD
  local height_to:DWORD

  invoke GetDlgItem,hWnd,id
  mov ecx,eax
  invoke GetWindowRect,ecx,addr rt
  invoke MapWindowPoints,0,hWnd,addr rt,2
  mov edi,rt.bottom
  mov top_to,edi
  invoke GetClientRect,hWnd,addr rt
  mov eax,rt.right
  mov width_to,eax
  mov eax,rt.bottom
  sub eax,edi
  mov height_to,eax
  mov eax,lP
  and eax,0E0h ; Ctrl || Shift || Alt
  push eax
  .if eax==0
    invoke DescendantWindowFromPoint,0,ptx,pty
  .else
    mov eax,hw
  .endif
  mov hW,eax
  invoke GetWindowRect,hW,addr rt  
  mov eax,rt.left
  sub ptx,eax
  mov eax,rt.top
  sub pty,eax
  invoke GetWindowLong,hWnd,GWL_USERDATA
  and eax,0ffffh
  mov ecx,eax       ; zoom
  mov eax,width_to
  xor edx,edx
  div ecx
  mov edi,eax       ; width_from
  mov eax,height_to
  xor edx,edx
  div ecx
  mov esi,eax       ; height_from
  mov eax,edi
  shr eax,1
  sub ptx,eax
  mov eax,esi
  shr eax,1
  sub pty,eax       ; centering
  invoke GetWindowDC,hW
  mov ebx,eax
  invoke CreateCompatibleDC,ebx
  mov hdcmem,eax
  invoke CreateCompatibleBitmap,ebx,edi,esi
  invoke SelectObject,hdcmem,eax
  pop ecx
  push eax
  .if CaptBlt!=0
    mov edx,SRCCOPY OR CAPTUREBLT
  .else
    mov edx,SRCCOPY
  .endif
  .if ecx==0
    invoke BitBlt,hdcmem,0,0,edi,esi,ebx,ptx,pty,edx  ; StretchBlt dosn't understand CAPTUREBLT
  .else
    mov eax,ecx
    and eax,40h ; Shift
    and ecx,20h ; Ctrl
;    and lP,80h ; Alt
    .if eax!=0
      .if ecx==0
        mov eax,PRF_NONCLIENT or PRF_ERASEBKGND or PRF_CLIENT or PRF_CHILDREN or PRF_OWNED ; or PRF_CHECKVISIBLE
      .else
        mov eax,PRF_NONCLIENT or PRF_ERASEBKGND ; or PRF_CLIENT or PRF_CHILDREN or PRF_OWNED ; or PRF_CHECKVISIBLE
      .endif
;      invoke DefWindowProc,hW,WM_PRINT,hdcmem,eax
      invoke SendMessage,hW,WM_PRINT,hdcmem,eax
    .elseif ecx!=0
      mov eax,rt.right
      sub eax,rt.left
      mov ecx,rt.bottom
      sub ecx,rt.top
      invoke BitBlt,hdcmem,0,0,eax,ecx,ebx,0,0,edx
    .else
;      invoke PrintWindow,hW,hdcmem,0  ; (WinOS>=XP)
      invoke GetModuleHandle,offset _user32
      invoke GetProcAddress,eax,offset _pw
      .if eax==0
        invoke MessageBeep,eax
        jmp @err
      .endif
      push 0
      push hdcmem
      push hW
      call eax
    .endif
  .endif
  invoke GetKeyState,VK_CAPITAL  ; (CapsLock trigger:  +/- aim)
  and eax,1
  jz @f
  push ebx
  push edi
  push esi
  shr edi,1
  shr esi,1
  dec edi
  dec esi
  mov ebx,2
  invoke SetPixel,hdcmem,edi,esi,Red
  add edi,ebx
  invoke SetPixel,hdcmem,edi,esi,Red
  add esi,ebx
  invoke SetPixel,hdcmem,edi,esi,Red
  sub edi,ebx  
  invoke SetPixel,hdcmem,edi,esi,Red
  pop esi
  pop edi
  pop ebx
@@:  
  xor eax,eax
  mov rt.left,eax
  mov rt.top,eax
  mov rt.right,edi
  mov rt.bottom,esi
  invoke FrameRect,hdcmem,addr rt,hbrush  ; metering frame
  inc top_to
  invoke StretchBlt,hdc,0,top_to,width_to,height_to,hdcmem,0,0,edi,esi,SRCCOPY
@err:
  pop eax
  invoke SelectObject,hdcmem,eax
  invoke DeleteObject,eax  ; hbmp
  invoke DeleteDC,hdcmem
  invoke ReleaseDC,hW,ebx
  mov eax,hW
  ret
ZoomFromPoint endp
